﻿Type=Class
Version=3.71
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
#Event: NewText (Text As String)
#Event: Terminated
#Event: SendFileProgress(progress As Double) 'progress from 0-1

'version: 1.00
'Class module
Sub Class_Globals
	Private mTarget As Object
	Private mEventName As String
	Private astreams As AsyncStreams
	Public charset As String = "UTF8"
	Private sb As StringBuilder
	
	Private countingStream As CountingInputStream
	Private totalSizeForSending As Long
	Private currentFile As String
	Public incomingFilename As String
	
	Public progTimer As Timer
	
	Public incoming As Boolean = False
	Public outgoing As Boolean = False
	
	Private lastCount As Long = 0
End Sub

Public Sub Initialize (TargetModule As Object, EventName As String, in As InputStream, out As OutputStream)
	mTarget = TargetModule
	mEventName = EventName
	'astreams.Initialize(In, out, "astreams")
	astreams.InitializePrefix(in, True, out, "astreams")
	sb.Initialize
	progTimer.Initialize("progTimer", 1000)
	astreams.StreamFolder = File.Combine(File.DirApp, "Temp")
	File.MakeDir(File.DirApp, "Temp")
End Sub

'Sends the text. Note that this method does not add end of line characters.
Public Sub Write(Text As String)
	Text = Text & Chr(10)
	astreams.Write(Text.GetBytes(charset))
End Sub

Private Sub astreams_NewData (Buffer() As Byte)
	Dim newDataStart As Int = sb.Length
	sb.Append(BytesToString(Buffer, 0, Buffer.Length, charset))
	Dim s As String = sb.ToString
	Dim start As Int = 0
	For i = newDataStart To s.Length - 1
		Dim c As Char = s.CharAt(i)
			If i = 0 And c = Chr(10) Then '\n...
			start = 1 'might be a broken end of line character
			Continue
		End If
		If c = Chr(10) Then '\n
			CallSubDelayed2(mTarget, mEventName & "_NewText", s.SubString2(start, i))
			start = i + 1
		Else If c = Chr(13) Then '\r
			CallSubDelayed2(mTarget, mEventName & "_NewText", s.SubString2(start, i))
			If i < s.Length - 1 And s.CharAt(i + 1) = Chr(10) Then '\r\n
				i = i + 1
			End If
			start = i + 1
		End If
	Next
	If start > 0 Then sb.Remove(0, start)
End Sub

Private Sub astreams_NewStream (Dir As String, FileName As String)
	progTimer.Enabled = False
	progTimer_Tick
	incoming = False
	lastCount = 0
	
	File.Copy(Dir, FileName, File.Combine(File.DirApp, "Temp"), incomingFilename)
	File.Delete(Dir, FileName)
	Main.cl.ColorLogLine("", "", "")
	Main.cl.ColorLogWordLeft("File received:", "", "", 23).ColorLogLine(File.Combine(File.Combine(File.DirApp, "Temp"),incomingFilename), "aqua", "")
	Main.cl.ColorLogWordLeft("File.Size (MB):", "", "", 23).ColorLogLine(NumberFormat2(File.Size(File.Combine(File.DirApp, "Temp"),incomingFilename)/(1000*1000),1,2,2,False),"yellow","")
End Sub

Private Sub astreams_Terminated
	CallSubDelayed(mTarget, mEventName & "_Terminated")
End Sub

Private Sub astreams_Error
	Log("error: " & LastException)
	astreams.Close
	CallSubDelayed(mTarget, mEventName & "_Terminated")
End Sub

Public Sub Close
	astreams.Close
End Sub

Public Sub SendFile(Dir As String, FileName As String)
	outgoing = True
	Dim totalSizeForSending As Long = File.Size(Dir, FileName)
	Dim In As InputStream = File.OpenInput(Dir, FileName)
	countingStream.Initialize(In)
	currentFile = FileName.SubString(FileName.LastIndexOf("/") + 1)
	astreams.Write(currentFile.GetBytes("UTF8")) 'write the file name
	astreams.WriteStream(countingStream, totalSizeForSending)
	progTimer.Enabled = True
	progTimer_Tick
End Sub

Public Sub progTimer_Tick
	Dim prog As Double
	Dim speed As Double
	Dim progbarLength As Int = 60
	If incoming Then
		Dim strmRd As Long = astreams.StreamReceived
		prog = strmRd/astreams.StreamTotal
		speed = (1000.0/progTimer.Interval)*(strmRd - lastCount)/(1000*1000)
		lastCount = strmRd
	Else If outgoing Then
		Dim strmSnt As Long = countingStream.Count
		prog = strmSnt/totalSizeForSending
		speed = (1000.0/progTimer.Interval)*(strmSnt-lastCount)/(1000*1000)
		lastCount = strmRd
	End If
	Main.logProgressBar(progbarLength, prog, speed)
	If prog>0.99 And outgoing Then
		lastCount = 0
		progTimer.Enabled = False
		outgoing = False
		Main.cl.ColorLogLine("","","")
	End If
End Sub
